<template>
  <div>
    <h2> Edytuj swoje dane: </h2>
    <form
        v-on:submit.prevent="submitForm"
    >

      <div class="form-group">
        <label for="beekeperName">Twoje imię: </label>
        <input type="text"
               maxlength="20"
               class="form-control"
               id="beekeperName"
               placeholder="Imię"
               @input="e => this.form.beekeperName = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label for="beekeperSurname">Twoje nazwisko: </label>
        <input type="text"
               maxlength="20"
               class="form-control"
               id="beekeperSurname"
               placeholder="Nazwisko"
               @input="e => this.form.beekeperSurname = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label for="email">Twój email: </label>
        <input type="email"
               maxlength="50"
               class="form-control"
               id="email"
               placeholder="email"
               @input="e => this.form.email = e.target.value"
               required
        >
      </div>

      <div class="form-group">
        <label for="postCode">Twój kod pocztowy: </label>
        <input type="text"
               maxlength="9"
               class="form-control"
               id="postCode"
               placeholder="Kod pocztowy"
               pattern="^[0-9]{2}-[0-9]{3}$"
               @input="e => this.form.postCode = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label for="city">Twoje miejsce zamieszkania: </label>
        <input type="text"
               maxlength="20"
               class="form-control"
               id="city"
               placeholder="Miasto"
               @input="e => this.form.city = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label for="road">Ulica: </label>
        <input type="text"
               maxlength="20"
               class="form-control"
               id="road"
               placeholder="Ulica"
               @input="e => this.form.road = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <label for="roadNr">Nr domu: </label>
        <input type="text"
               maxlength="10"
               class="form-control"
               id="roadNr"
               placeholder="Nr"
               @input="e => this.form.beekeperSurname = e.target.value"
               required
        />
      </div>

      <div class="form-group">
        <button class="btn btn-primary">Edytuj</button>
      </div>

      <div>
        <button class="btn btn-dark" v-on:click="getBackToUser()">Anuluj</button>
      </div>
    </form>

  </div>
</template>

<script>
import UserService from '../../services/user.service';
import edituserdetailsobject from '../../models/edituserdetailsobject.js'


export default {
  name: 'EditUserDetails',
  data() {
    return {
      form: new edituserdetailsobject('', '', '', '', '', '', '', ''),
      response: '',
      actualUserDetails: ''
    }
  },
  computed: {
    currentUser() {
      return this.$store.state.auth.user;
    }
  },

  mounted() {

    if (!this.currentUser) {
      this.$router.push('/login');
    } else {
      UserService.getUserBoard(this.currentUser.id).then(
          response => {
            this.actualUserDetails = response.data[0];

            document.getElementById("beekeperName").value = this.actualUserDetails.beekeperName;
            document.getElementById("beekeperSurname").value = this.actualUserDetails.beekeperSurname;
            document.getElementById("email").value = this.actualUserDetails.email;
            document.getElementById("postCode").value = this.actualUserDetails.postCode;
            document.getElementById("city").value = this.actualUserDetails.city;
            document.getElementById("road").value = this.actualUserDetails.road;
            document.getElementById("roadNr").value = this.actualUserDetails.roadNr;

          },
          error => {
            this.actualUserDetails =
                (error.response && error.response.data && error.response.data.message) ||
                error.message ||
                error.toString();
          }
      );
    }
  },

  methods: {

    submitForm() {
      if (!this.currentUser) {
        this.$router.push('/login');
      } else if (this.$route.query.userDetailsId) {

        if (!this.form.beekeperName)
          this.form.beekeperName = this.actualUserDetails.beekeperName
        if (!this.form.beekeperSurname)
          this.form.beekeperSurname = this.actualUserDetails.beekeperSurname
        if (!this.form.email)
          this.form.email = this.actualUserDetails.email
        if (!this.form.postCode)
          this.form.postCode = this.actualUserDetails.postCode
        if (!this.form.city)
          this.form.city = this.actualUserDetails.city
        if (!this.form.road)
          this.form.road = this.actualUserDetails.road
        if (!this.form.roadNr)
          this.form.roadNr = this.actualUserDetails.roadNr

        this.form.id = this.$route.query.userDetailsId


        if (this.validEmail(this.form.email)) {

          UserService.editUserDetails(this.form, this.currentUser.id).then(
              response => {
                this.response = response.data;
                alert('Dane zedytowane poprawnie')
                this.$router.push('/profile');
              },
              error => {
                this.response =
                    (error.response && error.response.data && error.response.data.message) ||
                    error.message ||
                    error.toString();
              }
          )
        }
      } else if (!this.validEmail(this.form.email)) {
        alert('Podaj poprawny email!')
      }
    },

    validEmail: function (email) {
      let re = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      return re.test(email);
    },

    getBackToUser() {
      this.$router.push('/profile');
    }
  }
};

</script>

<style scoped>
label {
  display: block;
  margin-top: 10px;
}
</style>